#include <iostream>
#include <ctime>
#include <cstdlib>


using namespace std;

#define MAX_SIZE 200000

void readArray(int arr[], int &n, int maxsize){//beolvassa az n értékét (mely nem lehet nagyobb a harmadik paraméterként megadott maximális értéknél)
  cout<<"MAX array size (n):"<<maxsize<<endl;  //majd beolvassa az arr tömb elemeit
  do{
    cout<<"n=";cin>>n;
  }
  while(n>maxsize);

  for(int i=0;i<n;i++){
    cout<<"arr["<<i<<"]=";cin>>arr[i];
  }
}

void generateArray(int arr[],int n){//n db. 1 es 100 kozotti veletlenszeruen generalt egesszel tolti fel az arr tombot
    srand((unsigned)time(0));
    for(int i=0;i<n;i++){
        arr[i]=1+rand()%100;
    }
}

void writeoutArray(int arr[],int n){
  for(int i=0;i<n;i++){
    cout<<"arr["<<i<<"]="<<arr[i]<<endl;
  }
}


void bubbleSort(int arr[], int n){
 bool voltcsere;
  int meddig, csereind;
  meddig=n-1;
  do{
    voltcsere=false;
    for(int i=0;i<meddig;i++){
        if(arr[i]>arr[i+1]){
            int tmp=arr[i];
            arr[i]=arr[i+1];
            arr[i+1]=tmp;
            csereind=i;
            voltcsere=true;
        }
    }
    meddig=csereind;
   }while(voltcsere);
}

void selectSort (int arr[],int n){
   for(int i=0;i<n;i++)
   {
       int min=arr[i],mini=i;
       for(int j=i+1;j<n;j++)
       {
           if(arr[j]<min){
            min=arr[j];
            mini=j;
           }
       }
       int a=arr[mini];arr[mini]=arr[i];arr[i]=a;
   }
}


void insertSort(int n, int arr[])
{
    int x,j;
    for(int i=1;i<n;i++)
        if(arr[i]<arr[i-1])
    {
        x=arr[i];
        j=i-1;
        while(x<arr[j] && j>=0)
        {
            arr[j+1]=arr[j];
            j--;
        }
        arr[j+1]=x;
    }
}

void osszehasonlitoSzamlaloRendezes(int a[], int b[],int n){
    //csak kulonbozo ertekekre mukodik jol (feladat: atirni, hogy akkor is jol mukodjon, ha vannak ismetlodo ertekek az a tombben)
int k;
  for(int i=0;i<n;i++){
    k=0;
    for(int j=0;j<n;j++){
        if(a[i]>a[j]){
            k++;
        }
    }
    //ismetlodo elemek is lehetnek:
    // while(b[k]==a[i]){k++;}
     b[k]=a[i];
  }
  for(int i=0;i<n;i++){
    a[i]=b[i];
  }
}





void quickSort(int arr[], int left, int right) {
      int i = left, j = right;
      int tmp;
      int pivot = arr[(left + right) / 2];


      /* feloszt */
      while (i <= j) {
            while (arr[i] < pivot)
                  i++;
            while (arr[j] > pivot)
                  j--;
            if (i <= j) {
                  tmp = arr[i];
                  arr[i] = arr[j];
                  arr[j] = tmp;
                  i++;
                  j--;
            }
      };

      /* rekurzív hívás */
      if (left < j)
            quickSort(arr, left, j);
      if (i < right)
            quickSort(arr, i, right);
}

void quickSort2(int arr[], int left, int right) {
      int i = left, j = right;
      int tmp;
//      int pivot = arr[left];
      bool jobbrol = true;

      /* feloszt */
      while (i != j) {
            if(jobbrol){
                 while ((arr[i] <= arr[j])&&(i!=j))
                  j--;
            }
            else{
                 while ((arr[i] <= arr[j])&&(i!=j))
                  i++;
            }
            if(arr[i]>arr[j]){//csere
                tmp=arr[i];
                arr[i]=arr[j];
                arr[j]=tmp;
                jobbrol=! jobbrol;
            }
      }

      /* rekurziv hivas */
      if (left < i-1)
            quickSort(arr, left, i-1);
      if (j+1 < right)
            quickSort(arr, j+1, right);
}

int main()
{
  int t[MAX_SIZE]={3,6,5,7,1,9,3,2};
  int s[MAX_SIZE];
  int n=100;


  //readArray(t,n,MAX_SIZE);


  generateArray(t,n);

  cout<<"Az eredeti tomb: "<<endl;
  writeoutArray(t,n);

    //rendezes: ...
    //bubbleSort(t,n);
    //selectSort(t,n);
    //insertSort(n,t);
    //osszehasonlitoSzamlaloRendezes(t,s,n);
    quickSort(t,0,n-1);
    //quickSort2(t,0,n-1);

  cout<<"A rendezett tomb: "<<endl;
  writeoutArray(t,n);



    return 0;
}
